// GENERATED CODE - DO NOT MODIFY BY HAND

part of example.basic_auth.server;

// **************************************************************************
// Generator: ApiGenerator
// Target: class LibraryApi
// **************************************************************************

class JaguarLibraryApi implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[];

  final LibraryApi _internal;
  final JaguarAuthRoutes _authInternal;
  final JaguarStudentRoutes _studentInternal;

  factory JaguarLibraryApi() {
    final instance = new LibraryApi();
    return new JaguarLibraryApi.from(instance);
  }
  JaguarLibraryApi.from(this._internal)
      : _authInternal = new JaguarAuthRoutes.from(_internal.auth),
        _studentInternal = new JaguarStudentRoutes.from(_internal.student);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    prefix += '/api';
    {
      Response response =
          await _authInternal.handleRequest(request, prefix: prefix);
      if (response is Response) {
        return response;
      }
    }

    {
      Response response =
          await _studentInternal.handleRequest(request, prefix: prefix);
      if (response is Response) {
        return response;
      }
    }

    return null;
  }
}

// **************************************************************************
// Generator: RouteGroupGenerator
// Target: class AuthRoutes
// **************************************************************************

class JaguarAuthRoutes implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[
    const Post(path: '/login'),
    const Post(path: '/logout')
  ];

  final AuthRoutes _internal;

  factory JaguarAuthRoutes() {
    final instance = new AuthRoutes();
    return new JaguarAuthRoutes.from(instance);
  }
  JaguarAuthRoutes.from(this._internal);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    ContextImpl ctx = new ContextImpl(request);
    bool match = false;

//Handler for login
    match = routes[0]
        .match(request.uri.path, request.method, prefix, ctx.pathParams);
    if (match) {
      Response<dynamic> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor0;
      BasicAuth iBasicAuth0;
      try {
        final RouteWrapper wSessionInterceptor0 =
            _internal.sessionInterceptor();
        iSessionInterceptor0 = wSessionInterceptor0.createInterceptor();
        SessionManager rSessionInterceptor0 = await iSessionInterceptor0.pre(
          request,
        );
        ctx.addOutput(SessionInterceptor, wSessionInterceptor0.id,
            iSessionInterceptor0, rSessionInterceptor0);
        final RouteWrapper wBasicAuth0 = const WrapBasicAuth(kModelManager);
        iBasicAuth0 = wBasicAuth0.createInterceptor();
        UserModel rBasicAuth0 = await iBasicAuth0.pre(
          request.headers.value('authorization'),
          ctx.getInput(SessionInterceptor),
        );
        ctx.addOutput(BasicAuth, wBasicAuth0.id, iBasicAuth0, rBasicAuth0);
        _internal.login(
          request,
        );
        Response<dynamic> rRouteResponse1 = await iSessionInterceptor0.post(
          request,
          rRouteResponse0,
        );
        return rRouteResponse1;
      } catch (e) {
        await iBasicAuth0?.onException();
        await iSessionInterceptor0?.onException();
        rethrow;
      }
    }

//Handler for logout
    match = routes[1]
        .match(request.uri.path, request.method, prefix, ctx.pathParams);
    if (match) {
      Response<dynamic> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor0;
      try {
        final RouteWrapper wSessionInterceptor0 =
            _internal.sessionInterceptor();
        iSessionInterceptor0 = wSessionInterceptor0.createInterceptor();
        SessionManager rSessionInterceptor0 = await iSessionInterceptor0.pre(
          request,
        );
        ctx.addOutput(SessionInterceptor, wSessionInterceptor0.id,
            iSessionInterceptor0, rSessionInterceptor0);
        _internal.logout();
        Response<dynamic> rRouteResponse1 = await iSessionInterceptor0.post(
          request,
          rRouteResponse0,
        );
        return rRouteResponse1;
      } catch (e) {
        await iSessionInterceptor0?.onException();
        rethrow;
      }
    }

    return null;
  }
}

// **************************************************************************
// Generator: RouteGroupGenerator
// Target: class StudentRoutes
// **************************************************************************

class JaguarStudentRoutes implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[
    const Get(path: '/all'),
    const Get(path: '/:id', headers: const {'sample-header': 'sample-value'})
  ];

  final StudentRoutes _internal;

  factory JaguarStudentRoutes() {
    final instance = new StudentRoutes();
    return new JaguarStudentRoutes.from(instance);
  }
  JaguarStudentRoutes.from(this._internal);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    prefix += '/book';
    ContextImpl ctx = new ContextImpl(request);
    bool match = false;

//Handler for getAllBooks
    match = routes[0]
        .match(request.uri.path, request.method, prefix, ctx.pathParams);
    if (match) {
      Response<String> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor0;
      UserAuthoriser iUserAuthoriser0;
      try {
        final RouteWrapper wSessionInterceptor0 =
            _internal.sessionInterceptor();
        iSessionInterceptor0 = wSessionInterceptor0.createInterceptor();
        SessionManager rSessionInterceptor0 = await iSessionInterceptor0.pre(
          request,
        );
        ctx.addOutput(SessionInterceptor, wSessionInterceptor0.id,
            iSessionInterceptor0, rSessionInterceptor0);
        final RouteWrapper wUserAuthoriser0 =
            const WrapUserAuthoriser(kModelManager);
        iUserAuthoriser0 = wUserAuthoriser0.createInterceptor();
        UserModel rUserAuthoriser0 = await iUserAuthoriser0.pre(
          request,
          ctx.getInput(SessionInterceptor),
        );
        ctx.addOutput(UserAuthoriser, wUserAuthoriser0.id, iUserAuthoriser0,
            rUserAuthoriser0);
        rRouteResponse0 = _internal.getAllBooks();
        Response<dynamic> rRouteResponse1 = await iUserAuthoriser0.post(
          request,
          rRouteResponse0,
          ctx.getInput(SessionInterceptor),
        );
        Response<dynamic> rRouteResponse2 = await iSessionInterceptor0.post(
          request,
          rRouteResponse1,
        );
        return rRouteResponse2;
      } catch (e) {
        await iUserAuthoriser0?.onException();
        await iSessionInterceptor0?.onException();
        rethrow;
      }
    }

//Handler for getBook
    match = routes[1]
        .match(request.uri.path, request.method, prefix, ctx.pathParams);
    if (match) {
      Response<String> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor0;
      UserAuthoriser iUserAuthoriser0;
      try {
        final RouteWrapper wSessionInterceptor0 =
            _internal.sessionInterceptor();
        iSessionInterceptor0 = wSessionInterceptor0.createInterceptor();
        SessionManager rSessionInterceptor0 = await iSessionInterceptor0.pre(
          request,
        );
        ctx.addOutput(SessionInterceptor, wSessionInterceptor0.id,
            iSessionInterceptor0, rSessionInterceptor0);
        final RouteWrapper wUserAuthoriser0 =
            const WrapUserAuthoriser(kModelManager);
        iUserAuthoriser0 = wUserAuthoriser0.createInterceptor();
        UserModel rUserAuthoriser0 = await iUserAuthoriser0.pre(
          request,
          ctx.getInput(SessionInterceptor),
        );
        ctx.addOutput(UserAuthoriser, wUserAuthoriser0.id, iUserAuthoriser0,
            rUserAuthoriser0);
        rRouteResponse0.statusCode = 200;
        rRouteResponse0.headers['sample-header'] = 'sample-value';
        rRouteResponse0.headers
            .set('content-type', 'text/plain; charset=utf-8');
        rRouteResponse0.value = _internal.getBook(
          (ctx.pathParams.getField('id')),
        );
        Response<dynamic> rRouteResponse1 = await iUserAuthoriser0.post(
          request,
          rRouteResponse0,
          ctx.getInput(SessionInterceptor),
        );
        Response<dynamic> rRouteResponse2 = await iSessionInterceptor0.post(
          request,
          rRouteResponse1,
        );
        return rRouteResponse2;
      } catch (e) {
        await iUserAuthoriser0?.onException();
        await iSessionInterceptor0?.onException();
        rethrow;
      }
    }

    return null;
  }
}
